﻿Imports System.Threading
Imports System.Net
Imports System.Web
Public Class main
    Dim weblistener As HttpListener
    Dim lastpos As New Point(0, 0)
    Dim startpos As New Point(0, 0)
    Dim lastmouseseq As Integer = 0
    Dim nexttoggleclick As UInteger = MouseEventFlags.MOUSEEVENTF_LEFTDOWN Or MouseEventFlags.MOUSEEVENTF_RIGHTDOWN Or MouseEventFlags.MOUSEEVENTF_MIDDLEDOWN Or MouseEventFlags.MOUSEEVENTF_XDOWN

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles StartButton.Click
        If Not weblistener Is Nothing Then
            weblistener.Abort()
            weblistener = Nothing
            log("Stopped")
            My.Settings("listenport") = CUShort(PortInput.Value)
            My.Settings.Save()
            StartButton.BackColor = Color.Lime
            StartButton.Text = "Start"
        Else
            Dim listenport As UShort = My.Settings("listenport")
            PortInput.Value = listenport
            Try
                weblistener = New HttpListener
                weblistener.Prefixes.Add("http://*:" & listenport & "/")
                weblistener.Start()
            Catch ex As Exception
                log(ex.ToString)
            End Try
            Dim listenthread As New Thread(AddressOf listenforconnection)
            listenthread.Start()
            log("Started")
            StartButton.BackColor = Color.Red
            StartButton.Text = "Stop"
        End If

    End Sub

    Public Sub listenforconnection()
        Dim context As HttpListenerContext = Nothing
        Dim resp As HttpListenerResponse
        Dim respstr As String = String.Empty
        Dim leftclicking As Boolean = False
        While weblistener.IsListening
            Try
                context = weblistener.GetContext()
            Catch ex As Exception
                If weblistener Is Nothing OrElse weblistener.IsListening = False Then
                    Exit Sub
                End If
            End Try
            resp = context.Response
            Dim path As String = context.Request.Url.AbsolutePath
            log(context.Request.RemoteEndPoint.ToString & " " & context.Request.RawUrl)
            ' check for valid command packets

            If path = "/" Then
                respstr = FileIO.FileSystem.ReadAllText("res/page.html")
            Else
                respstr = handleinput(context.Request)
            End If

            If String.IsNullOrEmpty(respstr) Then
                respstr = "bad"
            End If
            Dim respbytes As Byte() = System.Text.Encoding.UTF8.GetBytes(respstr)
            resp.ContentLength64 = respbytes.Length
            resp.OutputStream.Write(respbytes, 0, respbytes.Length)
            resp.OutputStream.Close()
            resp.Close()
            'perftimer.Reset()
        End While
    End Sub

    Private Sub Form1_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        My.Settings.taptolerance = TapInput.Value
        If Not weblistener Is Nothing Then
            weblistener.Abort()
        End If
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Control.CheckForIllegalCrossThreadCalls = False
        Dim taptolerance As Integer = My.Settings.taptolerance
        TapInput.Value = taptolerance
        Button1_Click(sender, e)
    End Sub
    Private Sub log(str As String)
        Dim oldtext As String = LogText.Text
        Dim oldsplit() As String = oldtext.Split(vbNewLine)
        Dim newtext As String
        newtext = Now.ToString("[HH:mm:ss.fff] ") & str & vbNewLine
        For i = 0 To Math.Min(oldsplit.Length - 1, 5)
            newtext &= oldsplit(i) & vbNewLine
        Next

        LogText.Text = newtext
    End Sub

    Private Function handleinput(req As HttpListenerRequest) As String
        Dim split() As String = req.Url.AbsolutePath.Split({"/"}, StringSplitOptions.RemoveEmptyEntries)
        If split.Length < 1 Then
            Return "bad"
        End If
        Dim opt As String = split(0)

        Select Case opt

            Case "start"  'start of trackpad touch
                lastpos.X = req.QueryString("x")
                lastpos.Y = req.QueryString("y")
                startpos.X = req.QueryString("x")
                startpos.Y = req.QueryString("y")
                lastmouseseq = 0

            Case "move"   'trackpad touch move
                Dim seq As Integer = req.QueryString("seq")
                If seq > lastmouseseq Then
                    mouse_event(MouseEventFlags.MOUSEEVENTF_MOVE, req.QueryString("x") - lastpos.X, req.QueryString("y") - lastpos.Y, 0, 0)
                    lastpos.X = req.QueryString("x")
                    lastpos.Y = req.QueryString("y")
                    lastmouseseq = seq
                End If

            Case "end"
                Dim tol As Integer = TapInput.Value
                If (Math.Abs(req.QueryString("x") - startpos.X) < tol) And (Math.Abs(req.QueryString("y") - startpos.Y) < tol) Then
                    mouse_event(MouseEventFlags.MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0)
                    System.Threading.Thread.Sleep(10)
                    mouse_event(MouseEventFlags.MOUSEEVENTF_LEFTUP, 0, 0, 0, 0)
                End If

            Case "click"
                Dim eventflag As UInteger = 0
                Select Case req.QueryString("button")
                    Case "left"
                        eventflag = MouseEventFlags.MOUSEEVENTF_LEFTDOWN
                    Case "right"
                        eventflag = MouseEventFlags.MOUSEEVENTF_RIGHTDOWN
                    Case "middle"
                        eventflag = MouseEventFlags.MOUSEEVENTF_MIDDLEDOWN
                    Case "x"
                        eventflag = MouseEventFlags.MOUSEEVENTF_XDOWN
                    Case Else
                        Return "unknown mouse button"
                End Select
                mouse_event(eventflag, 0, 0, 0, 0)
                System.Threading.Thread.Sleep(10)
                ' bit shift to the left is the corresponding button up event
                mouse_event(eventflag << 1, 0, 0, 0, 0)

            Case "toggle"
                Dim eventflagmask As UInteger = 0
                'buttonmask is just the 2 bits for the selected button
                Select Case req.QueryString("button")
                    Case "left"
                        eventflagmask = MouseEventFlags.MOUSEEVENTF_LEFTDOWN Or MouseEventFlags.MOUSEEVENTF_LEFTUP
                    Case "right"
                        eventflagmask = MouseEventFlags.MOUSEEVENTF_RIGHTDOWN Or MouseEventFlags.MOUSEEVENTF_RIGHTUP
                    Case "middle"
                        eventflagmask = MouseEventFlags.MOUSEEVENTF_MIDDLEDOWN Or MouseEventFlags.MOUSEEVENTF_MIDDLEUP
                    Case "x"
                        eventflagmask = MouseEventFlags.MOUSEEVENTF_XDOWN Or MouseEventFlags.MOUSEEVENTF_XUP
                    Case Else
                        Return "unknown mouse button"
                End Select

                'nexttoggleclick is either button up or down for each button
                mouse_event(eventflagmask And nexttoggleclick, 0, 0, 0, 0)
                'invert nexttoggleclick for the selected button only
                nexttoggleclick = nexttoggleclick Xor eventflagmask

            Case "wheel"
                Dim eventflag As UInteger = 0
                Select Case req.QueryString("axis")
                    Case "vert"
                        eventflag = MouseEventFlags.MOUSEEVENTF_WHEEL
                    Case "horiz"
                        eventflag = MouseEventFlags.MOUSEEVENTF_HWHEEL

                End Select
                mouse_event(eventflag, 0, 0, req.QueryString("delta"), 0)

            Case "key"
                Try
                    Dim vk As Byte = req.QueryString("code")
                    keybd_press(vk)
                Catch ex As Exception
                    log(ex.ToString)
                End Try

            Case "text"
                Dim encodedtext As String = req.QueryString("text")
                Dim decodedtext As String = Uri.UnescapeDataString(encodedtext)
                Try
                    SendKeysEscaped(decodedtext)
                Catch ex As Exception
                    log(ex.ToString)
                End Try

            Case "sendkeys"
                Dim keys As String = req.QueryString("keys")
                Try
                    SendKeys.SendWait(keys)
                Catch ex As Exception
                    log(ex.ToString)
                End Try

            Case Else
                Return "bad"

        End Select
        Return "ok"
    End Function


End Class
